<template>
  <div id="app">
    <div id="nav">
      <router-link to="/">Home</router-link> |
      <router-link to="/about">About</router-link>
    </div>
    <router-view/>
  </div>
</template>

<style lang="scss">
#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}
#nav {
  padding: 30px;
  a {
    font-weight: bold;
    color: #2c3e50;
    &.router-link-exact-active {
      color: #42b983;
    }
  }
}
</style>

<script>
  import axios from 'axios'
  import { mapMutations } from 'vuex'

  export default {
    methods: {
      ...mapMutations(['AUTH_LOGOUT'])
    },
    created() {
      axios.interceptors.response.use(undefined, function (err) {
        return new Promise(function () {
          if (err.status === 401 && err.config && !err.config.__isRetryRequest) {
            // получается если пришел статус 401 то мы удаляем токен
            this.AUTH_LOGOUT()
            // и после этого редиректим на страницу логина
          }
          throw err;
        });
      });
    }
  }
</script>
